package cz.jzitnik.chronos.interactions.list;

import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.entities.Item;
import cz.jzitnik.chronos.entities.ItemType;
import cz.jzitnik.chronos.entities.Player;
import cz.jzitnik.chronos.interactions.InteractionPlayer;
import cz.jzitnik.chronos.payload.responses.InteractionResponse;
import cz.jzitnik.chronos.repository.CharacterRepository;
import cz.jzitnik.chronos.services.ItemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class Mayor implements InteractionPlayer {
    @Autowired
    private ItemService itemService;
    @Autowired
    private CharacterRepository characterRepository;

    @Override
    public InteractionResponse play(Player player, Character character, String data) {
        var playerItems = player.getInventory();
        var golderWatches = playerItems.stream().filter(item -> item.getItemType().equals(ItemType.GOLDEN_WATCH)).toList();

        if (golderWatches.isEmpty()) {
            return new InteractionResponse(false, "Golden watch is not present in your inventory!", new ArrayList<>());
        }

        var golderWatch = golderWatches.getFirst();
        playerItems.remove(golderWatch);

        var item = new Item(ItemType.KEY_FRAGMENT, player);
        itemService.addItem(player, item); // itemRepository.save is ran by this function so we don't need to save the player when we removed the item from his inv

        character.setInteractedWith(true);
        characterRepository.save(character);

        var items = new ArrayList<Item>();
        items.add(item);

        return new InteractionResponse(false, "Díky moc za mé ztracené zlaté hodinky... Doplnit dialog!!!", items);
    }
}
